#include <windows.h>
#include <gdiplus.h>
using namespace Gdiplus;
#include <vector>
using namespace std;
#include <stdio.h>

#include "tp_stub.h"

/**
 * Oo͗p
 */
static void log(const tjs_char *format, ...)
{
	va_list args;
	va_start(args, format);
	tjs_char msg[1024];
	_vsnwprintf(msg, 1024, format, args);
	TVPAddLog(msg);
	va_end(args);
}

// GDI {
GdiplusStartupInput gdiplusStartupInput;
ULONG_PTR gdiplusToken;

/*
 * Cɒ GDI+ ێ邽߂̃lCeBuCX^X
 */
class NI_GdiPlusInfo : public tTJSNativeInstance
{
protected:

	/// CQƂrbg}bv
	Bitmap * _bitmap;
	/// Cɑ΂ĕ`悷ReLXg
	Graphics * _graphics;

	/// C
	tjs_int _width;
	tjs_int _height;
	tjs_int _pitch;
	const tjs_uint8 * _buffer;

public:
	/**
	 * GDI+ p`OtBbN
	 * C̃rbg}bv񂪕ύXĂ\̂Ŗ`FbNB
	 * ύXĂꍇ͕`p̃ReLXgg݂Ȃ
	 * @param layerobj CIuWFNg
	 */
	void resetGraphics(iTJSDispatch2 *layerobj) {
		
		// C摜obt@擾
		const tjs_uint8 * buffer;
		tjs_int pitch;
		tjs_int width;
		tjs_int height;
		
		tTJSVariant val;
		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("imageWidth"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.imageWidth failed."));
		width = val;
		
		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("imageHeight"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.imageHeight failed."));
		height = val;
		
		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("mainImageBufferForWrite"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.mainImageBuffer failed."));
		buffer = (const tjs_uint8 *)(tjs_int)val;
		
		if(TJS_FAILED(layerobj->PropGet(0, TJS_W("mainImageBufferPitch"), NULL, &val, layerobj)))
			TVPThrowExceptionMessage(TJS_W("invoking of Layer.mainImageBufferPitch failed."));
		pitch = val;

		if (_graphics &&
			width == _width &&
			height == _height &&
			pitch == _pitch &&
			buffer == _buffer) {
		} else {
			delete _graphics;
			delete _bitmap;
			_width = width;
			_height = height;
			_pitch = pitch;
			_buffer = buffer;
			_bitmap = new Bitmap(_width, _height, _pitch, PixelFormat32bppARGB, (unsigned char*)_buffer);
			_graphics = new Graphics(_bitmap);
		}
	}
	
protected:
	/// yێp
	vector<Pen*>_pens;
public:
	/**
	 * y̏
	 */
	void clearPen() {
		vector<Pen*>::iterator i = _pens.begin();
		while (i != _pens.end()) {
			delete *i;
			i = _pens.erase(i);
		}
	}
	/**
	 * ŒFy̒ǉ
	 */
	void addSolidPen(ARGB argb, REAL width=1.0) {
		_pens.push_back(new Pen(Color(argb), width));
	}

protected:
	/// tHgێp
	Font *_font;

public:
	/**
	 * tHgݒ
	 * @param familyName tHgt@~[
	 * @param emSize TCYw(pixcelP)
	 * @param style tHgX^C
	 */
	void setFont(const tjs_char *familyName, REAL emSize, INT style=FontStyleRegular) {
		delete _font;
		FontFamily  fontFamily(familyName);
		_font = new Font(&fontFamily, emSize, FontStyleRegular, UnitPixel);
	}
	
public:
	/**
	 * RXgN^
	 */
	NI_GdiPlusInfo() {
		_bitmap = NULL;
		_graphics = NULL;
		_width = 0;
		_height = 0;
		_pitch = 0;
		_buffer = NULL;
		_font = NULL;
	}

	/**
	 * fXgN^
	 */
	~NI_GdiPlusInfo() {
		clearPen();
		delete _font;
		delete _graphics;
		delete _bitmap;
	}

	// ------------------------------------------------------------------
	// `惁\bhQ
	// ------------------------------------------------------------------
public:

	/**
	 * ʂ̏
	 * @param argb F
	 */
	void clear(ARGB argb = 0x00000000) {
		_graphics->Clear(Color(argb));
	}
	
	/**
	 * ̕`
	 * @param text `eLXg
	 */
	void drawString(REAL x, REAL y, const tjs_char *text) {
		// tHgꍇɌ
		if (_font) {
			PointF      pointF(x, y);
			vector<Pen*>::iterator i = _pens.begin();
			while (i != _pens.end()) {
				_graphics->DrawString(text, -1, _font, pointF, (*i)->GetBrush());
				i++;
			}
		}
	}

	/**
	 * ̕`
	 * @param x1 n_XW
	 * @param y1 n_YW
	 * @param x2 I_XW
	 * @param y2 I_YW
	 */
	void drawLine(REAL x1, REAL y1, REAL x2, REAL y2) {
		vector<Pen*>::iterator i = _pens.begin();
		while (i != _pens.end()) {
			_graphics->DrawLine(*i, x1, y1, x2, y2);
			i++;
		}
	}

	/**
	 * `̕`
	 * @param x1 n_XW
	 * @param y1 n_YW
	 * @param x2 I_XW
	 * @param y2 I_YW
	 */
	void drawRectangle(REAL x1, REAL y1, REAL x2, REAL y2) {
		RectF rectf(x1, y1, x2-x1+1, y2-y1+1);
		vector<Pen*>::iterator i = _pens.begin();
		while (i != _pens.end()) {
			_graphics->DrawRectangle(*i, rectf);
			i++;
		}
	}

};

// NXID
static tjs_int32 ClassID_GdiPlusInfo = -1;

/**
 * CIuWFNg GDI+ plCeBuCX^X擾B
 * lCeBuCX^XĂȂꍇ͎IɊ蓖Ă
 * @param objthis CIuWFNg
 * @return GDI+ plCeBuCX^XB擾s NULL
 */
NI_GdiPlusInfo *
getGdiPlusNative(iTJSDispatch2 *layerobj)
{
	if (!layerobj) return NULL;

	NI_GdiPlusInfo *_this;
	if (TJS_FAILED(layerobj->NativeInstanceSupport(TJS_NIS_GETINSTANCE,
												   ClassID_GdiPlusInfo, (iTJSNativeInstance**)&_this))) {
		_this = new NI_GdiPlusInfo();
		if (TJS_FAILED(layerobj->NativeInstanceSupport(TJS_NIS_REGISTER,
													   ClassID_GdiPlusInfo, (iTJSNativeInstance **)&_this))) {
			return NULL;
		}
	}
	_this->resetGraphics(layerobj);
	return _this;
}

/**
 * y
 */
class tClearPenFunction : public tTJSDispatch
{
protected:
public:
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) {

		NI_GdiPlusInfo *_this;
		if ((_this = getGdiPlusNative(objthis)) == NULL) return TJS_E_NATIVECLASSCRASH;
		_this->clearPen();

		return TJS_S_OK;
	}
};


/**
 * y
 */
class tAddSolidPenFunction : public tTJSDispatch
{
protected:
public:
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) {

		NI_GdiPlusInfo *_this;
		if ((_this = getGdiPlusNative(objthis)) == NULL) return TJS_E_NATIVECLASSCRASH;

		if (numparams < 1) return TJS_E_BADPARAMCOUNT;

		if (numparams < 2) {
			_this->addSolidPen(param[0]->AsInteger());
		} else {
			_this->addSolidPen(param[0]->AsInteger(), param[1]->AsReal());
		}

		return TJS_S_OK;
	}
};

/**
 * tHgݒ
 */
class tSetFontFunction : public tTJSDispatch
{
protected:
public:
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) {

		NI_GdiPlusInfo *_this;
		if ((_this = getGdiPlusNative(objthis)) == NULL) return TJS_E_NATIVECLASSCRASH;
		
		if (numparams < 2) return TJS_E_BADPARAMCOUNT;

		if (numparams < 3) {
			_this->setFont(param[0]->GetString(), param[1]->AsReal());
		} else {
			_this->setFont(param[0]->GetString(), param[1]->AsReal(), param[2]->AsInteger());
		}
		
		return TJS_S_OK;
	}
};

/**
 * ʏ
 */
class tClearFunction : public tTJSDispatch
{
protected:
public:
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) {

		NI_GdiPlusInfo *_this;
		if ((_this = getGdiPlusNative(objthis)) == NULL) return TJS_E_NATIVECLASSCRASH;

		if (numparams < 1) {
			_this->clear();
		} else {
			_this->clear(param[0]->AsInteger());
		}

		return TJS_S_OK;
	}
};


/**
 * eLXg`
 */
class tDrawStringFunction : public tTJSDispatch
{
protected:
public:
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) {

		NI_GdiPlusInfo *_this;
		if ((_this = getGdiPlusNative(objthis)) == NULL) return TJS_E_NATIVECLASSCRASH;
		
		if (numparams < 3) return TJS_E_BADPARAMCOUNT;
		
		_this->drawString(param[0]->AsReal(), param[1]->AsReal(), param[2]->GetString());
		
		return TJS_S_OK;
	}
};

/**
 * `
 */
class tDrawLineFunction : public tTJSDispatch
{
protected:
public:
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) {

		NI_GdiPlusInfo *_this;
		if ((_this = getGdiPlusNative(objthis)) == NULL) return TJS_E_NATIVECLASSCRASH;
		
		if (numparams < 4) return TJS_E_BADPARAMCOUNT;
		
		_this->drawLine(param[0]->AsReal(), param[1]->AsReal(), param[2]->AsReal(), param[3]->AsReal());
		
		return TJS_S_OK;
	}
};

/**
 * ``
 */
class tDrawRectangleFunction : public tTJSDispatch
{
protected:
public:
	tjs_error TJS_INTF_METHOD FuncCall(
		tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) {

		NI_GdiPlusInfo *_this;
		if ((_this = getGdiPlusNative(objthis)) == NULL) return TJS_E_NATIVECLASSCRASH;
		
		if (numparams < 4) return TJS_E_BADPARAMCOUNT;
		
		_this->drawRectangle(param[0]->AsReal(), param[1]->AsReal(), param[2]->AsReal(), param[3]->AsReal());
		
		return TJS_S_OK;
	}
};


//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason,
	void* lpReserved)
{
	return 1;
}

void
addMethod(iTJSDispatch2 *dispatch, const tjs_char *methodName, tTJSDispatch *method)
{
	tTJSVariant var = tTJSVariant(method);
	method->Release();
	dispatch->PropSet(
		TJS_MEMBERENSURE, // oȂꍇɂ͍쐬悤ɂtO
		methodName, // o ( Ȃ炸 TJS_W( ) ň͂ )
		NULL, // qg ( {̓õnbVlANULL ł悢 )
		&var, // o^l
		dispatch // ReLXg
		);
}


//---------------------------------------------------------------------------
static tjs_int GlobalRefCountAtInit = 0;
extern "C" HRESULT _stdcall _export V2Link(iTVPFunctionExporter *exporter)
{
	// X^ȕ(KLq)
	TVPInitImportStub(exporter);

	// Initialize GDI+.
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	
	// NXIuWFNgo^
	ClassID_GdiPlusInfo = TJSRegisterNativeClass(TJS_W("GdiPlusInfo"));

	{
		// TJS ̃O[oIuWFNg擾
		iTJSDispatch2 * global = TVPGetScriptDispatch();

		// Layer NXIuWFNg擾
		tTJSVariant varScripts;
		TVPExecuteExpression(TJS_W("Layer"), &varScripts);
		iTJSDispatch2 *dispatch = varScripts.AsObjectNoAddRef();
		if (dispatch) {
			addMethod(dispatch, L"gpClearPen",    new tClearPenFunction());
			addMethod(dispatch, L"gpAddSolidPen", new tAddSolidPenFunction());
			addMethod(dispatch, L"gpSetFont",     new tSetFontFunction());

			addMethod(dispatch, L"gpClear",       new tClearFunction());
			addMethod(dispatch, L"gpDrawString",  new tDrawStringFunction());

			addMethod(dispatch, L"gpDrawLine",  new tDrawLineFunction());
			addMethod(dispatch, L"gpDrawRectangle",  new tDrawRectangleFunction());
		}

		global->Release();
	}
			
	// ̎_ł TVPPluginGlobalRefCount ̒l
	GlobalRefCountAtInit = TVPPluginGlobalRefCount;
	// ƂčTĂBTVPPluginGlobalRefCount ͂̃vOC
	// ǗĂ tTJSDispatch hIuWFNg̎QƃJE^̑vŁA
	// ɂ͂ƓAȂȂĂȂƂȂȂB
	// ȂĂȂ΁Aǂʂ̂ƂŊ֐ȂǂQƂĂāA
	// vOC͉łȂƌƂɂȂB

	return S_OK;
}
//---------------------------------------------------------------------------
extern "C" HRESULT _stdcall _export V2Unlink()
{
	// ggAvOC悤ƂƂɌĂ΂֐B

	// 炩̏ŃvOCłȂꍇ
	// ̎_ E_FAIL Ԃ悤ɂB
	// ł́ATVPPluginGlobalRefCount  GlobalRefCountAtInit 
	// 傫ȂĂΎsƂƂɂB
	if(TVPPluginGlobalRefCount > GlobalRefCountAtInit) return E_FAIL;
		// E_FAIL AƁAPlugins.unlink \bh͋UԂ

	// TJS ̃O[oIuWFNgɓo^ average ֐Ȃǂ폜

	// - ܂ATJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// - global  DeleteMember \bhpAIuWFNg폜
	if(global)
	{
		// TJS ̂ɉĂƂȂǂ
		// global  NULL ɂȂ蓾̂ global  NULL łȂ
		// Ƃ`FbN

		global->DeleteMember(
			0, // tO ( 0 ł悢 )
			TJS_W("average"), // o
			NULL, // qg
			global // ReLXg
			);
	}

	// - global  Release 
	if(global) global->Release();

	GdiplusShutdown(gdiplusToken);
	
	// X^u̎gpI(KLq)
	TVPUninitImportStub();

	return S_OK;
}
